﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Diagnostics;
using System.IO;
using Newtonsoft.Json.Linq;

namespace esl
{
    class MobileCaptureRest
    {
        public static void main()
        {

            string apiKey = Properties.Settings.Default.key;
            string url = "https://sandbox.esignlive.com/api";

            string jsonString = "{\"documents\":[{\"approvals\":[{\"id\":\"ExampleSignatureId\",\"role\":\"Signer1\",\"fields\":[{\"page\":0,\"top\":100,\"subtype\":\"MOBILE_CAPTURE\",\"height\":50,\"left\":100,\"width\":200,\"type\":\"SIGNATURE\",\"name\":\"ExampleSignatureId\"}],\"name\":\"\"}],\"id\":\"sample-contract\",\"name\":\"Example document\"}],\"status\":\"SENT\",\"type\":\"PACKAGE\",\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail32@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}],\"name\":\"Signer1\"}],\"name\":\"Mobile Capture Example Package\"}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes(@"C:/Users/hhaidary/Desktop/PDFs/doc1.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"doc1.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"doc1.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}
